#!/usr/bin/env ruby

require 'sdl'

SDL.init( SDL::INIT_VIDEO )
screen = SDL::setVideoMode(640,480,16,SDL::SWSURFACE)
SDL::WM::setCaption('testsprite.rb','testsprite.rb icon')
image = SDL::Surface.loadBMP("icon.bmp")
image.setColorKey( SDL::SRCCOLORKEY ,0)
$image = image.displayFormat

class Sprite
  def initialize
    @x=rand(640-32)
    @y=rand(480-32)
    @dx=rand(3)-1
    @dy=rand(3)-1
    while @dx == 0 && @dy == 0
      @dx=rand(3)-1
      @dy=rand(3)-1
    end
  end
  
  def move
    @x += @dx
    if @x < 0 || @x >= 640-32 then
      @dx = -@dx
      @x += @dx
    end
    @y += @dy
    if @y < 0 || @y >= 480-32 then
      @dy = -@dy
      @y += @dy
    end
  end
  
  def draw(screen)
    SDL.blitSurface($image,0,0,32,32,screen,@x,@y)
  end
  
end

sprites = []
for i in 1..100
  sprites << Sprite.new
end

frame = 0
first = SDL.getTicks()

while true
  while event = SDL::Event2.poll
    case event
    when SDL::Event2::KeyDown, SDL::Event2::Quit
	  elapsed = SDL.getTicks() - first
	  fps = 1.0 * frame * 1000 / elapsed
	  print "#{fps} frames per second\n"
      exit
    end
  end
  screen.fillRect(0,0,640,480,0)
  
  sprites.each {|i|
    i.move
    i.draw(screen)
  }
  screen.updateRect(0,0,0,0)

  frame = frame + 1
end
